// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "femmview.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_PT_PROP, OnPtProp)
	ON_COMMAND(ID_SHOW_TBAR, OnShowTbar)
	ON_WM_INITMENU()
	//}}AFX_MSG_MAP
	// Global help commands
//	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
//	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
//	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
//	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

static UINT BASED_CODE arToolButtons[]=
{
	ID_MENU_POINT,
	ID_MENU_CONTOUR,
	ID_MENU_AREA,
		ID_SEPARATOR,
	ID_SHOW_GRID,
	ID_SNAP_GRID,
	ID_SET_GRID,
		ID_SEPARATOR,
	ID_MENU_PLOT,
	ID_MENU_INTEGRATE,
		ID_SEPARATOR,
	ID_SHOW_MESH,
	ID_CPLOT,
	ID_DPLOT,
		ID_SEPARATOR,
	ID_ZOOM_IN,
	ID_ZOOM_OUT,
	ID_ZOOM_NATURAL,
	ID_ZOOM_WINDOW,
	ID_PAN_LEFT,
	ID_PAN_UP,
	ID_PAN_DOWN,
	ID_PAN_RIGHT,
};
/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
/*	int colorlist[][3]=
	{{0x0,	0xff,	0xf1},{0x0,	0xff,	0xf2},{0x0,	0xff,	0xf3},
	{0x0,	0xff,	0xf4},{0x0,	0xff,	0xf5},{0x0,	0xff,	0xf6},
	{0x0,	0xff,	0xf7},{0x0,	0xff,	0xf8},{0x0,	0xff,	0xf9},
	{0x0,	0xff,	0xfa},{0x0,	0xff,	0xfb},{0x0,	0xff,	0xfc},
	{0x0,	0xff,	0xfd},{0x0,	0xff,	0xfe},{0x0,	0xff,	0xff},
	{0x0,	0xff,	0xf},{0x2a,	0x1b,	0xeb},{0x7f,	0x7f,	0x7f},
	{0x80,	0x80,	0x80},{0xd5,	0xe4,	0x14},{0xff,	0x0,	0x0},
	{0xff,	0x0,	0x10},{0xff,	0x0,	0x11},{0xff,	0x0,	0x12},
	{0xff,	0x0,	0x13},{0xff,	0x0,	0x14},{0xff,	0x0,	0x1},
	{0xff,	0x0,	0x2},{0xff,	0x0,	0x3},{0xff,	0x0,	0x4},
	{0xff,	0x0,	0x5},{0xff,	0x0,	0x6},{0xff,	0x0,	0x7},
	{0xff,	0x0,	0x8},{0xff,	0x0,	0x9},{0xff,	0x0,	0xa},
	{0xff,	0x0,	0xb},{0xff,	0x0,	0xc},{0xff,	0x0,	0xd},
	{0xff,	0x0,	0xeb},{0xff,	0x0,	0xec},{0xff,	0x0,	0xed},
	{0xff,	0x0,	0xee},{0xff,	0x0,	0xef},{0xff,	0x0,	0xe},
	{0xff,	0x0,	0xf0},{0xff,	0x0,	0xf1},{0xff,	0x0,	0xf2},
	{0xff,	0x0,	0xf3},{0xff,	0x0,	0xf4},{0xff,	0x0,	0xf5},
	{0xff,	0x0,	0xf6},{0xff,	0x0,	0xf7},{0xff,	0x0,	0xf8},
	{0xff,	0x0,	0xf9},{0xff,	0x0,	0xfa},{0xff,	0x0,	0xfb},
	{0xff,	0x0,	0xfc},{0xff,	0x0,	0xfd},{0xff,	0x0,	0xfe},
	{0xff,	0x0,	0xff},{0xff,	0x0,	0xf},{0xff,	0x1f,	0xff},
	{0xff,	0x2d,	0xff},{0xff,	0x3b,	0xff},{0xff,	0x49,	0xff},
	{0xff,	0x57,	0xff},{0xff,	0x65,	0xff},{0xff,	0x73,	0xff},
	{0xff,	0x81,	0xff},{0xff,	0x8f,	0xff},{0xff,	0x9d,	0xff},
	{0xff,	0xab,	0xff},{0xff,	0xb9,	0xff},{0xff,	0xc7,	0xff},
	{0xff,	0xd5,	0xff},{0xff,	0xe3,	0xff},{0xff,	0xf1,	0xff},
	{0xff,	0xff,	0x0},{0xff,	0xff,	0xff}};
	int i;

	pPal = (LOGPALETTE*) malloc(sizeof(LOGPALETTE) 
                    + 124 * sizeof(PALETTEENTRY));
	pPal->palVersion=0x300;
	pPal->palNumEntries=0x80;
	for(i=0;i<124;i++)
	{
		pPal->palPalEntry[i].peRed=colorlist[i][0];
		pPal->palPalEntry[i].peGreen=colorlist[i][1];
		pPal->palPalEntry[i].peBlue=colorlist[i][2];
		pPal->palPalEntry[i].peFlags=NULL;
	}
	
	myPalette.CreatePalette(pPal); */
}

CMainFrame::~CMainFrame()
{
//	free(pPal);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// create output window;
	EnableDocking(0);
	m_dlgBar.Create(this,IDD_OUTBOX,CBRS_TOP,IDD_OUTBOX);
	m_dlgBar.SetWindowText("Femmview Output");
	m_dlgBar.EnableDocking(0);
	CRect rc;
	GetClientRect(&rc);
	ClientToScreen(&rc);
	CPoint p=rc.BottomRight();
	p.x-=175; p.y-=300;
	FloatControlBar(&m_dlgBar,p);

	// flash up title;
	{
		char s[80];
		sprintf(s,"Femmview version 3.0");
		m_dlgBar.SetDlgItemText(IDC_LINE1,s);
		sprintf(s,"Magnetics finite element postprocessor");
		m_dlgBar.SetDlgItemText(IDC_LINE2,s);
		sprintf(s,"Copyright 1998-2000");
		m_dlgBar.SetDlgItemText(IDC_LINE4,s);
		sprintf(s,"David Meeker");
		m_dlgBar.SetDlgItemText(IDC_LINE5,s);
		sprintf(s,"dcm3c@aol.com");
		m_dlgBar.SetDlgItemText(IDC_LINE6,s);
		sprintf(s,"http://members.aol.com/dcm3c");
		m_dlgBar.SetDlgItemText(IDC_LINE7,s);
		sprintf(s," ");
		m_dlgBar.SetDlgItemText(IDC_LINE8,s);
		sprintf(s,"");
		m_dlgBar.SetDlgItemText(IDC_LINE9,s);
		sprintf(s,"");
		m_dlgBar.SetDlgItemText(IDC_LINE10,s);
	}

	// Create a toolbar
	m_toolBar.Create(this);
	m_toolBar.SetWindowText("FEMM Postprocessor Tools");
	m_toolBar.LoadBitmap(IDB_TOOLS);
	m_toolBar.SetButtons(arToolButtons,
		sizeof(arToolButtons)/sizeof(UINT));
	m_toolBar.EnableDocking(CBRS_ALIGN_TOP);
	EnableDocking(CBRS_ALIGN_TOP);
	DockControlBar( &m_toolBar );
	UINT nOldStyle=m_toolBar.GetBarStyle();
	m_toolBar.SetBarStyle(nOldStyle | CBRS_TOOLTIPS | CBRS_FLYBY);
	
	return 0;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnPtProp() 
{
	if( (m_dlgBar.GetStyle() & WS_VISIBLE) != 0 ){
		ShowControlBar(&m_dlgBar,FALSE,FALSE);
	}
	else{
		ShowControlBar(&m_dlgBar,TRUE,FALSE);
	}
}

void CMainFrame::OnShowTbar() 
{
	// TODO: Add your command handler code here
	if( (m_toolBar.GetStyle() & WS_VISIBLE) != 0 ){
		ShowControlBar(&m_toolBar,FALSE,FALSE);
	}
	else{
		ShowControlBar(&m_toolBar,TRUE,FALSE);
	}
}

/*
void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	if (pFocusWnd == this) return;
	OnQueryNewPalette();
}

BOOL CMainFrame::OnQueryNewPalette() 
{
	CDC* pDC=GetDC();
	CPalette *oldPalette=pDC->SelectPalette(&myPalette,FALSE);
	int i=pDC->RealizePalette();
	pDC->SelectPalette(oldPalette,TRUE);
	pDC->RealizePalette();
	ReleaseDC(pDC);
	return i;
}
*/




void CMainFrame::OnInitMenu(CMenu* pMenu) 
{
	CFrameWnd::OnInitMenu(pMenu);

	if( (m_toolBar.GetStyle() & WS_VISIBLE) != 0 ){
		// make sure that toolbar entry is checked
		pMenu->CheckMenuItem(ID_SHOW_TBAR, MF_CHECKED);
	}
	else{
		// make sure that toolbar entry is not checked
		pMenu->CheckMenuItem(ID_SHOW_TBAR, MF_UNCHECKED);
	}
	
	if( (m_dlgBar.GetStyle() & WS_VISIBLE) != 0 ){
		// make sure that toolbar entry is checked
		pMenu->CheckMenuItem(ID_PT_PROP, MF_CHECKED);
	}
	else{
		// make sure that toolbar entry is not checked
		pMenu->CheckMenuItem(ID_PT_PROP, MF_UNCHECKED);
	}	
	
}

