
#define PI 3.141592653589793238462643383
#define SmallNo 1.e-14

class CComplex
{
	public:

		CComplex();
		CComplex Sqrt();
		CComplex Conj();
		CComplex Inv();
		void Set(double x, double y);
		double Abs();
		double Arg();
		double Re();
		double Im();
		char* ToString(char *s);
		double re,im;
	
	private:

};

CComplex Mult(CComplex a, CComplex b);
CComplex Mult(double a, CComplex b);
CComplex Mult(CComplex a, double b);

CComplex Div(CComplex a, CComplex b);
CComplex Div(CComplex a, double b);
CComplex Div(double a, CComplex b);

CComplex Add(CComplex a, CComplex b);
CComplex Add(CComplex b, double a);
CComplex Add(double a, CComplex b);

CComplex Subt(CComplex a, CComplex b);
CComplex Subt(CComplex a, double b);
CComplex Subt(double a, CComplex b);

double cRe(CComplex a);
double cIm(CComplex a);

CComplex exp(CComplex x);
CComplex sqrt(CComplex x);
CComplex tanh(CComplex x);
CComplex log(CComplex x);
CComplex pow(CComplex x, double y);
CComplex pow(CComplex x, CComplex y);

double abs(CComplex x);
double arg(CComplex x);


